//------------------------------------------------------------------------------
//  SubDoubleInt.cpp -     
//    ,    
//------------------------------------------------------------------------------

#include "IntClass.h"
#include "DoubleClass.h"
#include "Matrix.h"

//------------------------------------------------------------------------------
//       
Int& GetRegInt();
//       
Double& GetRegDouble();

//    
Matrix& GetSubtMatr();

//------------------------------------------------------------------------------
//  ()     
Double* SubIntDouble(Int& n1, Double& n2)
{
	return new Double(n1._value - n2._value);
}

//------------------------------------------------------------------------------
//      .
//        ,
//     .
Number* SubIntDouble(Number& n1, Number& n2)
{
	Int* pInt1;
	Double* pDouble2;
	//       
	if( (pInt1 = dynamic_cast<Int*>(&n1)) &&
	    (pDouble2 = dynamic_cast<Double*>(&n2))	)
	{
		//    
		return SubIntDouble(*pInt1, *pDouble2);
	}
	else
	{
		//   .   .
		return 0;
	}

}

//------------------------------------------------------------------------------
//      
namespace {
	//   
	class regIntDouble
	{
	public:
		// ,   
		regIntDouble()
		{
			Int& regInt = GetRegInt();
			Double& regDouble = GetRegDouble();

			//       
			//      ()
			//   
			int Int_rank = regInt.GetRank();
			int Double_rank = regDouble.GetRank();

			Matrix& subtMatr = GetSubtMatr();
			subtMatr.Insert(SubIntDouble, Int_rank, Double_rank);
		}
	};

	//   
	regIntDouble IntDoubleFun;

} // namespace

//------------------------------------------------------------------------------
//  ()     
Double* SubDoubleInt(Double& n1, Int& n2)
{
	return new Double(n1._value - n2._value);
}

//------------------------------------------------------------------------------
//      .
//        ,
//     .
Number* SubDoubleInt(Number& n1, Number& n2)
{
	Double* pDouble1;
	Int* pInt2;
	//       
	if( (pDouble1 = dynamic_cast<Double*>(&n1)) &&
	    (pInt2 = dynamic_cast<Int*>(&n2))	)
	{
		//    
		return SubDoubleInt(*pDouble1, *pInt2);
	}
	else
	{
		//   .   .
		return 0;
	}

}

//------------------------------------------------------------------------------
//       
namespace {
	//   
	class regDoubleInt
	{
	public:
		// ,   
		regDoubleInt()
		{
			Int& regInt = GetRegInt();
			Double& regDouble = GetRegDouble();
		
			//       
			//      ()
			//   
			int Int_rank = regInt.GetRank();
			int Double_rank = regDouble.GetRank();

			Matrix& subtMatr = GetSubtMatr();
			subtMatr.Insert(SubDoubleInt, Double_rank, Int_rank);
		}
	};

	//   
	regDoubleInt DoubleIntFun;

} // namespace
//------------------------------------------------------------------------------
